#ifndef PROGRAMMER_H
#define PROGRAMMER_H

#include "entity.h"
#include "olcPGE_Common.h"

namespace pabloader {

class Programmer : public Entity {
protected:
    uint32_t tileCounter = 0;
    bool onGround = false;
    bool doJump = false;
    bool walkLeft = false;
    bool walkRight = false;
    bool moveDown = false;

public:
    Programmer(Debuggers* game);
    virtual void Think();
    virtual void Update(float dt) override;
    virtual void Draw() override;
    bool IsOnGround() { return onGround; }
    uint8_t GetSkin() { return tileX; }
    void UpgradeLevel() { tileX = std::min(tileX + 1, tileCols - 1); }
};
}

#endif